# Copyright 2023 Akretion - Raphaël Valyi <raphael.valyi@akretion.com>
# License LGPL-3.0 or later (https://www.gnu.org/licenses/lgpl-3.0.en.html).
# Generated by https://github.com/akretion/xsdata-odoo
#
import textwrap
from odoo import fields, models

__NAMESPACE__ = "http://www.portalfiscal.inf.br/cte"

"""Descrição do Evento - “Cancelamento do Comprovante de Entrega do
    CT-e”"""
EVCANCCECTE_DESCEVENTO = [
    (
        "Cancelamento do Comprovante de Entrega do CT-e",
        "Cancelamento do Comprovante de Entrega do CT-e",
    ),
]


class EvCancCecte(models.AbstractModel):
    """Schema XML de validação do evento cancelamento do comprovante de entrega
    eletrônico do CT-e
    110181"""

    _description = textwrap.dedent("    %s" % (__doc__,))
    _name = "cte.40.evcanccecte"
    _inherit = "spec.mixin.cte"
    _binding_type = "EvCancCecte"

    cte40_descEvento = fields.Selection(
        EVCANCCECTE_DESCEVENTO,
        string="Descrição do Evento",
        xsd_required=True,
        help=(
            "Descrição do Evento - “Cancelamento do Comprovante de Entrega do "
            "CT-e”"
        ),
    )

    cte40_nProt = fields.Char(
        string="Número do Protocolo de autorização",
        xsd_required=True,
        xsd_type="TProt",
        help="Número do Protocolo de autorização do CT-e",
    )

    cte40_nProtCE = fields.Char(
        string="nProtCE",
        xsd_required=True,
        xsd_type="TProt",
        help="Número do Protocolo de autorização do evento a ser cancelado",
    )
