# Copyright 2023 Akretion - Raphaël Valyi <raphael.valyi@akretion.com>
# License LGPL-3.0 or later (https://www.gnu.org/licenses/lgpl-3.0.en.html).
# Generated by https://github.com/akretion/xsdata-odoo
#
import textwrap
from odoo import fields, models

__NAMESPACE__ = "http://www.portalfiscal.inf.br/cte"

"Descrição do Evento - “Cancelamento”"
EVCANCCTE_DESCEVENTO = [
    ("Cancelamento", "Cancelamento"),
]


class EvCancCte(models.AbstractModel):
    """Schema XML de validação do evento do cancelamento
    110111"""

    _description = textwrap.dedent("    %s" % (__doc__,))
    _name = "cte.40.evcanccte"
    _inherit = "spec.mixin.cte"
    _binding_type = "EvCancCte"

    cte40_descEvento = fields.Selection(
        EVCANCCTE_DESCEVENTO,
        string="Descrição do Evento - “Cancelamento”",
        xsd_required=True,
    )

    cte40_nProt = fields.Char(
        string="Número do Protocolo de Status do CT-e",
        xsd_required=True,
        xsd_type="TProt",
    )

    cte40_xJust = fields.Char(
        string="Justificativa do Cancelamento",
        xsd_required=True,
        xsd_type="TJust",
    )
