# Copyright 2023 Akretion - Raphaël Valyi <raphael.valyi@akretion.com>
# License LGPL-3.0 or later (https://www.gnu.org/licenses/lgpl-3.0.en.html).
# Generated by https://github.com/akretion/xsdata-odoo
#
import textwrap
from odoo import fields, models

__NAMESPACE__ = "http://www.portalfiscal.inf.br/cte"

"""Descrição do Evento - “Cancelamento Prestação do Serviço em
    Desacordo”"""
EVCANCPRESTDESACORDO_DESCEVENTO = [
    (
        "Cancelamento Prestação do Serviço em Desacordo",
        "Cancelamento Prestação do Serviço em Desacordo",
    ),
    (
        "Cancelamento Prestacao do Servico em Desacordo",
        "Cancelamento Prestacao do Servico em Desacordo",
    ),
]


class EvCancPrestDesacordo(models.AbstractModel):
    """Schema XML de validação do evento Cancelamento Prestação do Serviço em
    Desacordo 610111"""

    _description = textwrap.dedent("    %s" % (__doc__,))
    _name = "cte.40.evcancprestdesacordo"
    _inherit = "spec.mixin.cte"
    _binding_type = "EvCancPrestDesacordo"

    cte40_descEvento = fields.Selection(
        EVCANCPRESTDESACORDO_DESCEVENTO,
        string="Descrição do Evento",
        xsd_required=True,
        help=(
            "Descrição do Evento - “Cancelamento Prestação do Serviço em "
            "Desacordo”"
        ),
    )

    cte40_nProtEvPrestDes = fields.Char(
        string="Protocolo do evento que será cancelado",
        xsd_required=True,
        xsd_type="TProt",
        help=(
            "Protocolo do evento que será cancelado\nInformar o número do "
            "protocolo de autorização do evento de prestação de serviço em "
            "desacordo que será cancelado"
        ),
    )
