# Copyright 2023 Akretion - Raphaël Valyi <raphael.valyi@akretion.com>
# License LGPL-3.0 or later (https://www.gnu.org/licenses/lgpl-3.0.en.html).
# Generated by https://github.com/akretion/xsdata-odoo
#
import textwrap
from odoo import fields, models

__NAMESPACE__ = "http://www.portalfiscal.inf.br/cte"

"Descrição do Evento - “Registro Multimodal”"
EVREGMULTIMODAL_DESCEVENTO = [
    ("Registro Multimodal", "Registro Multimodal"),
]


class EvRegMultimodal(models.AbstractModel):
    "Schema XML de validação do evento Registro Multimodal 110160"

    _description = textwrap.dedent("    %s" % (__doc__,))
    _name = "cte.40.evregmultimodal"
    _inherit = "spec.mixin.cte"
    _binding_type = "EvRegMultimodal"

    cte40_descEvento = fields.Selection(
        EVREGMULTIMODAL_DESCEVENTO,
        string="Descrição do Evento",
        xsd_required=True,
        help="Descrição do Evento - “Registro Multimodal”",
    )

    cte40_xRegistro = fields.Char(
        string="Informação complementar sobre o registro",
        xsd_required=True,
        help=(
            "Informação complementar sobre o registro, indicação do tipo de "
            "documento utilizado e demais situações ocorridas no Multimodal "
            "(Texto Livre)."
        ),
    )

    cte40_nDoc = fields.Char(
        string="Numero do Documento lançado",
        help="Numero do Documento lançado no CT-e Multimodal",
    )
